<template>
  <!-- eslint-disable vue/no-v-html -->
  <div class="relative bg-secondary-100">
    <!-- Hero Banner -->
    <section id="heroBanner">
      <transition name="fade">
        <HeroCarousel />
      </transition>
    </section>

    <!-- Categories -->
    <section id="categoriesCarousel" class="py-16">
      <div class="container mx-auto">
        <CategoriesCarousel v-if="categories" :categories="categories" />
      </div>
    </section>

    <!-- Products by New Arrivals -->
    <section id="byNewArrivals" class="py-16 mb-16">
      <div class="container mx-auto">
        <div class="flex items-center justify-between mb-5">
          <h3 class="text-xl font-medium">New arrivals</h3>
          <nuxt-link
            to="/shop"
            class="flex items-center justify-center text-primary-300 hover:text-primary-400"
          >
            See more
            <i class="ml-2 text-3xl bx bx-chevron-right"></i>
          </nuxt-link>
        </div>
        <TeaserSkeletonCarousel v-if="!byNewArrivalsProducts" />
        <TeaserCarousel v-else :products="byNewArrivalsProducts" />
      </div>
    </section>

    <!-- CTA -->
    <section
      id="offersCta"
      class="bg-fixed bg-no-repeat bg-cover"
      :style="`background-image: url(${productsCTA[0].backgroundImage});`"
    >
      <div class="py-16">
        <div class="container mx-auto">
          <nuxt-link :to="productsCTA[0].slug">
            <div class="grid grid-cols-1 px-5 md:grid-cols-3 cta-container">
              <div class="flex items-center justify-center col-span-1">
                <h3 class="text-3xl uppercase" v-html="productsCTA[0].text" />
              </div>

              <div class="flex items-center justify-center col-span-1 my-5">
                <div
                  class="w-auto px-5 py-3 text-center text-white rounded bg-primary-300"
                >
                  <p class="text-sm font-light leading-none">From</p>
                  <p class="text-6xl font-extrabold leading-none">
                    <!-- <span class="-mr-3 text-2xl align-top">$</span> -->
                    {{ productsCTA[0].price.split('.')[0] }}
                    <span class="-ml-3 text-2xl align-top">
                      {{ productsCTA[0].price.split('.')[1] }}
                    </span>
                  </p>
                </div>
              </div>

              <div class="relative hidden h-full col-span-1 md:block">
                <img
                  class="absolute bottom-0 left-0 w-3/4"
                  :src="productsCTA[0].image"
                  :alt="productsCTA[0].text"
                />
              </div>
            </div>
          </nuxt-link>
        </div>
      </div>
    </section>

    <!-- Products by Offers -->
    <section id="byOffers" class="py-12">
      <div class="container mx-auto">
        <div class="flex items-center justify-between mb-5">
          <h3 class="text-xl font-medium">Offers</h3>
          <nuxt-link
            to="/offers"
            class="flex items-center justify-center text-primary-300 hover:text-primary-400"
          >
            See more
            <i class="ml-2 text-3xl bx bx-chevron-right"></i>
          </nuxt-link>
        </div>

        <div class="grid grid-cols-2 gap-5">
          <div class="col-span-2 md:col-span-1">
            <TeaserSkeleton v-if="!productsOnSale" class="h-full" />
            <Teaser v-else :product="productsOnSale[0]" class="h-full" />
          </div>
          <div class="col-span-2 md:col-span-1">
            <div v-if="productsOnSale" class="grid grid-cols-2 gap-5">
              <div
                v-for="(product, index) in productsOnSale.slice(1, 5)"
                :key="index"
                class="col-span-2 md:col-span-1"
              >
                <TeaserSkeleton v-if="!product" />
                <Teaser v-else :product="product" :index="index" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>

    <!-- Product by Total Sales -->
    <section id="byTotalSales" class="py-16">
      <div class="container mx-auto">
        <div class="flex items-center justify-between mb-5">
          <h3 class="text-xl font-medium">Best sales</h3>
          <nuxt-link
            to="/shop"
            class="flex items-center justify-center text-primary-300 hover:text-primary-400"
          >
            See more
            <i class="ml-2 text-3xl bx bx-chevron-right"></i>
          </nuxt-link>
        </div>
        <TeaserSkeletonCarousel v-if="!byTotalSalesProducts" />
        <TeaserCarousel v-else :products="byTotalSalesProducts" />
      </div>
    </section>

    <!-- Products CTA -->
    <section id="productsCTA">
      <div class="w-full mx-auto">
        <div class="grid grid-cols-2 gap-0">
          <CTA
            v-for="(cta, index) in productsCTA.slice(1)"
            :key="index"
            :cta="cta"
            class="col-span-2 mt-20 md:mt-0 md:col-span-1 first:mt-0"
          />
        </div>
      </div>
    </section>

    <!-- Product by Category -->
    <section id="byCategory" class="py-16 bg-secondary-100">
      <div class="container mx-auto">
        <div class="flex items-center justify-between mb-5">
          <h3 class="text-xl font-medium">{{ category.name }}</h3>
          <nuxt-link
            to="/shop"
            class="flex items-center justify-center text-primary-300 hover:text-primary-400"
          >
            See more
            <i class="ml-2 text-3xl bx bx-chevron-right"></i>
          </nuxt-link>
        </div>
        <TeaserSkeletonCarousel v-if="!byCategoryProducts" />
        <TeaserCarousel v-else :products="byCategoryProducts" />
      </div>
    </section>
  </div>
</template>

<script>
import HeroCarousel from '~/components/layout/parts/hero/HeroCarousel'
import CategoriesCarousel from '~/components/layout/parts/categories/CategoriesCarousel'
import Teaser from '~/components/product/Teaser'
import TeaserSkeleton from '~/components/product/TeaserSkeleton'
import TeaserCarousel from '~/components/product/TeaserCarousel'
import TeaserSkeletonCarousel from '~/components/product/TeaserSkeletonCarousel'
import CTA from '~/components/layout/parts/CTA.vue'

import getProducts from '~/apollo/queries/products/getProducts.gql'
import { CATEGORIES } from '~/constants.js'

export default {
  layout: 'default',
  components: {
    CTA,
    HeroCarousel,
    CategoriesCarousel,
    Teaser,
    TeaserSkeleton,
    TeaserCarousel,
    TeaserSkeletonCarousel,
  },
  data() {
    return {
      categories: CATEGORIES,
      category: {
        name: 'Wallets for men',
        slug: 'men-accessories-wallets',
      },
      productsCTA: [
        {
          backgroundImage:
            'https://admin.molygo.com/wp-content/uploads/cta_1_bg.png',
          text: 'Shop <br /> <span class="font-bold">exclusive brands</span>',
          slug: '/shop/michael-kors-charlotte_35t0scfs3l-blue',
          image: 'https://admin.molygo.com/wp-content/uploads/cta_bag.png',
          price: '$300.00',
        },
        {
          backgroundImage:
            'https://admin.molygo.com/wp-content/uploads/labial_bg.png',
          name: 'RB3025 <br /> <span class="font-bold">Ray-Ban</span>',
          slug: '/shop/ray-ban-rb3025-black',
          image: 'https://admin.molygo.com/wp-content/uploads/rayban-3025.webp',
          price: '$145.00',
        },
        {
          backgroundImage:
            'https://admin.molygo.com/wp-content/uploads/airmax_bg.png',
          name: 'AIRMAX DIA <br /> <span class="font-bold">Nike</span>',
          slug: '/shop/nike-airmaxdia-white',
          image:
            'https://admin.molygo.com/wp-content/uploads/nike-air-max-270.webp',
          price: '$121.00',
        },
      ],
    }
  },
  apollo: {
    byNewArrivalsProducts: {
      prefetch: false,
      query: getProducts,
      variables() {
        return {}
      },
      update(data) {
        return data.products.nodes
      },
    },
    productsOnSale: {
      prefetch: false,
      query: getProducts,
      variables() {
        return {
          first: 25,
          where: { onSale: true },
        }
      },
      update(data) {
        return data.products.nodes
      },
    },
    byTotalSalesProducts: {
      prefetch: false,
      query: getProducts,
      variables() {
        return {
          where: {
            orderby: [
              {
                field: 'PRICE', // TODO change to TOTAL_SALES
                order: 'DESC',
              },
            ],
          },
        }
      },
      update(data) {
        return data.products.nodes
      },
    },
    byCategoryProducts: {
      prefetch: false,
      query: getProducts,
      variables() {
        return {
          where: { category: 'men-accessories-wallets' },
        }
      },
      update(data) {
        return data.products.nodes
      },
    },
  },
}
</script>
